// -*- c++ -*-
// Copyright (C) 2002, 2003  EPITA Research and Development Laboratory
//
// This file is part of the Olena Library.  This library is free
// software; you can redistribute it and/or modify it under the terms
// of the GNU General Public License version 2 as published by the
// Free Software Foundation.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this library; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.
//
// As a special exception, you may use this file as part of a free
// software library without restriction.  Specifically, if other files
// instantiate templates or use macros or inline functions from this
// file, or you compile this file and link it with other files to
// produce an executable, this file does not by itself cause the
// resulting executable to be covered by the GNU General Public
// License.  This exception does not however invalidate any other
// reasons why the executable file might be covered by the GNU General
// Public License.


template<class I, class E1, class E2>
oln_concrete_type(I) 
  thinning(const abstract::non_vectorial_image<I>& input,
	   const abstract::struct_elt<E1>& se1,
	   const abstract::struct_elt<E2>& se2)
{
  mlc::eq<I::dim, E1::dim>::ensure();
  mlc::eq<I::dim, E2::dim>::ensure();

  oln_concrete_type(I) dilated = dilation(input, se2);
  oln_concrete_type(I) eroded = erosion(input, se1);
  oln_concrete_type(I) output(input.size());
  oln_iter_type(I) p(input);
  for_all(p)
    {
      if ((dilated[p] < input[p]) && (input[p] == eroded[p]))
	output[p] = dilated[p];
      else
	output[p] = input[p];
    }
  return output;
}
